bug-coreutils
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

Re: cat fionread usage bug?


From: Pádraig Brady
Subject: Re: cat fionread usage bug?
Date: Wed, 11 Mar 2009 11:54:35 +0000
User-agent: Thunderbird 2.0.0.6 (X11/20071008)

Pádraig Brady wrote:
> Jim Meyering wrote:
>>>> Would you like to handle it?
>>> will do
> 
> attached

oops, previous one didn't update tests/Makefile.am
>From 11e4014d8c8ffa0e26f8c4518e5e19ef9159869d Mon Sep 17 00:00:00 2001
From: =?utf-8?q?P=C3=A1draig=20Brady?= <address@hidden>
Date: Wed, 11 Mar 2009 11:39:33 +0000
Subject: [PATCH] cat: Fix immediate output of processed data

* NEWS: Mention the bugfix.
* src/cat.c (cat): Fix the typo which stopped the writing
of processed data before a blocking read() is done.
* tests/misc/cat-buf: Add to ensure processed data is not buffered.
* tests/Makefile.am: Reference the new test
---
 NEWS               |    5 +++++
 src/cat.c          |    2 +-
 tests/Makefile.am  |    1 +
 tests/misc/cat-buf |   41 +++++++++++++++++++++++++++++++++++++++++
 4 files changed, 48 insertions(+), 1 deletions(-)
 create mode 100755 tests/misc/cat-buf

diff --git a/NEWS b/NEWS
index fd101a4..752173d 100644
--- a/NEWS
+++ b/NEWS
@@ -4,6 +4,11 @@ GNU coreutils NEWS                                    -*- 
outline -*-
 
 ** Bug fixes
 
+  cat once again immediately outputs data it has processed.
+  Previously it would have been buffered and only output if enough
+  data was read, or on process exit.
+  [bug introduced in coreutils-6.0]
+
   comm's new --check-order option would fail to detect disorder on any pair
   of lines where one was a prefix of the other.  For example, this would
   fail to report the disorder: printf 'Xb\nX\n'>k; comm --check-order k k
diff --git a/src/cat.c b/src/cat.c
index 04eb204..da72c6e 100644
--- a/src/cat.c
+++ b/src/cat.c
@@ -339,7 +339,7 @@ cat (
                input_pending = true;
 #endif
 
-             if (input_pending)
+             if (!input_pending)
                write_pending (outbuf, &bpout);
 
              /* Read more input into INBUF.  */
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 07e9473..10be0c6 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -149,6 +149,7 @@ TESTS =                                             \
   misc/wc-files0-from                          \
   misc/wc-files0                               \
   misc/cat-proc                                        \
+  misc/cat-buf                                 \
   misc/base64                                  \
   misc/basename                                        \
   misc/close-stdout                            \
diff --git a/tests/misc/cat-buf b/tests/misc/cat-buf
new file mode 100755
index 0000000..fb9ae88
--- /dev/null
+++ b/tests/misc/cat-buf
@@ -0,0 +1,41 @@
+#!/bin/sh
+# Ensure that cat outputs processed data immediately.
+
+# Copyright (C) 2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+  set -x
+  cat --version
+fi
+
+. $srcdir/test-lib.sh
+
+# Use a fifo rather than a pipe in the tests below
+# so that the producer (cat) will wait until the
+# consumer (dd) opens the fifo therefore increasing
+# the chance that dd will read the data from each
+# write separately.
+mkfifo fifo || framework_failure
+
+echo '1' > exp
+
+dd count=1 if=fifo > out 2> err&
+(echo '1'; sleep .2; echo '2') | cat -v > fifo
+wait #for dd to complete
+
+compare out exp || fail=1
+
+Exit $fail
-- 
1.5.3.6


reply via email to

[Prev in Thread] Current Thread [Next in Thread]